Index: CKEditor/branches/versions/3.5.x/_dev/docs_build/docs_build.conf
===================================================================
--- CKEditor/branches/versions/3.5.x/_dev/docs_build/docs_build.conf	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_dev/docs_build/docs_build.conf	(revision 6050)
@@ -17,5 +17,6 @@
 		'../../_source/core/',
 		'../../_source/plugins/',
-		'../../_source/skins/kama/skin.js'
+		'../../_source/skins/kama/skin.js',
+		'../../_source/themes/default/theme.js'
 	],
 
Index: CKEditor/branches/versions/3.5.x/_source/core/_bootstrap.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/_bootstrap.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/_bootstrap.js	(revision 6050)
@@ -67,7 +67,5 @@
 	});
 
-/*
-TODO: Enable the following and check if effective.
-
+// Needed for IE6 to not request image (HTTP 200 or 304) for every CSS background. (#6187)
 if ( CKEDITOR.env.ie )
 {
@@ -83,5 +81,12 @@
 	}
 }
-*/
+
+/**
+ * Indicates that CKEditor is running on a High Contrast environment.
+ * @name CKEDITOR.env.hc
+ * @example
+ * if ( CKEDITOR.env.hc )
+ *     alert( 'You're running on High Contrast mode. The editor interface will get adapted to provide you a better experience.' );
+ */
 
 /**
Index: CKEditor/branches/versions/3.5.x/_source/core/ajax.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/ajax.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/ajax.js	(revision 6050)
@@ -10,6 +10,5 @@
 
 /**
- * Ajax methods for data loading.
- * @namespace
+ * @namespace Ajax methods for data loading.
  * @example
  */
Index: CKEditor/branches/versions/3.5.x/_source/core/ckeditor.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/ckeditor.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/ckeditor.js	(revision 6050)
@@ -107,7 +107,27 @@
 
 /**
+ * The editor which is currently active (have user focus).
+ * @name CKEDITOR.currentInstance
+ * @type CKEDITOR.editor
+ * @see CKEDITOR#currentInstance
+ * @example
+ * function showCurrentEditorName()
+ * {
+ *     if ( CKEDITOR.currentInstance )
+ *         alert( CKEDITOR.currentInstance.name );
+ *     else
+ *         alert( 'Please focus an editor first.' );
+ * }
+ */
+
+/**
  * Fired when the CKEDITOR.currentInstance object reference changes. This may
  * happen when setting the focus on different editor instances in the page.
  * @name CKEDITOR#currentInstance
  * @event
+ * var editor;  // Variable to hold a reference to the current editor.
+ * CKEDITOR.on( 'currentInstance' , function( e )
+ *     {
+ *         editor = CKEDITOR.currentInstance;
+ *     });
  */
Index: CKEditor/branches/versions/3.5.x/_source/core/ckeditor_base.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/ckeditor_base.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/ckeditor_base.js	(revision 6050)
@@ -21,7 +21,6 @@
 {
 	/**
-	 * This is the API entry point. The entire CKEditor code runs under this object.
 	 * @name CKEDITOR
-	 * @namespace
+	 * @namespace This is the API entry point. The entire CKEditor code runs under this object.
 	 * @example
 	 */
@@ -53,5 +52,5 @@
 			 * @type String
 			 * @example
-			 * alert( CKEDITOR.version );  // e.g. 'CKEditor 3.0 Beta'
+			 * alert( CKEDITOR.version );  // e.g. 'CKEditor 3.4.1'
 			 */
 			version : '%VERSION%',
@@ -59,5 +58,6 @@
 			/**
 			 * Contains the CKEditor revision number.
-			 * Revision number is incremented automatically after each modification of CKEditor source code.
+			 * The revision number is incremented automatically, following each
+			 * modification to the CKEditor source code.
 			 * @type String
 			 * @example
@@ -146,10 +146,13 @@
 			 * Gets the full URL for CKEditor resources. By default, URLs
 			 * returned by this function contains a querystring parameter ("t")
-			 * set to the {@link CKEDITOR.timestamp} value.
+			 * set to the {@link CKEDITOR.timestamp} value.<br />
+			 * <br />
 			 * It's possible to provide a custom implementation to this
 			 * function by setting a global variable named CKEDITOR_GETURL.
 			 * This global variable must be set "before" the editor script
-			 * loading. If the custom implementation returns nothing, the
+			 * loading. If the custom implementation returns nothing (==null), the
 			 * default implementation is used.
+			 * @param {String} resource The resource to which get the full URL.
+			 *		It may be a full, absolute or relative URL.
 			 * @returns {String} The full URL.
 			 * @example
@@ -170,5 +173,5 @@
 
 				// Add the timestamp, except for directories.
-				if ( this.timestamp && resource.charAt( resource.length - 1 ) != '/' && !/[&?]t=/.test( resource ) )
+				if ( this.timestamp && resource.charAt( resource.length - 1 ) != '/' && !(/[&?]t=/).test( resource ) )
 					resource += ( resource.indexOf( '?' ) >= 0 ? '&' : '?' ) + 't=' + this.timestamp;
 
Index: CKEditor/branches/versions/3.5.x/_source/core/ckeditor_basic.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/ckeditor_basic.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/ckeditor_basic.js	(revision 6050)
@@ -30,5 +30,5 @@
 			if ( CKEDITOR.status != 'basic_ready' )
 			{
-				CKEDITOR.loadFullCore._load = true;
+				CKEDITOR.loadFullCore._load = 1;
 				return;
 			}
@@ -79,5 +79,5 @@
 		 * <b>CKEDITOR.replaceByClassEnabled</b> = false;
 		 */
-		CKEDITOR.replaceByClassEnabled = true;
+		CKEDITOR.replaceByClassEnabled = 1;
 
 		var createInstance = function( elementOrIdOrName, config, creationFunction, data )
@@ -139,8 +139,5 @@
 		};
 
-		/**
-		 * @ignore
-		 * Documented at ckeditor.js.
-		 */
+		// Documented at ckeditor.js.
 		CKEDITOR.add = function( editor )
 		{
@@ -176,7 +173,7 @@
 			for ( var i = 0 ; i < textareas.length ; i++ )
 			{
-				var config = null;
-				var textarea = textareas[i];
-				var name = textarea.name;
+				var config = null,
+					textarea = textareas[i],
+					name = textarea.name;
 
 				// The "name" and/or "id" attribute must exist.
Index: CKEditor/branches/versions/3.5.x/_source/core/command.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/command.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/command.js	(revision 6050)
@@ -4,8 +4,42 @@
 */
 
+/**
+ * Creates a command class instance.
+ * @class Represents a command that can be executed on an editor instance.
+ * @param {CKEDITOR.editor} editor The editor instance this command will be
+ *		related to.
+ * @param {CKEDITOR.commandDefinition} commandDefinition The command
+ *		definition.
+ * @augments CKEDITOR.event
+ * @example
+ * var command = new CKEDITOR.command( editor,
+ *     {
+ *         exec : function( editor )
+ *         {
+ *             alert( editor.document.getBody().getHtml() );
+ *         }
+ *     });
+ */
 CKEDITOR.command = function( editor, commandDefinition )
 {
+	/**
+	 * Lists UI items that are associated to this command. This list can be
+	 * used to interact with the UI on command execution (by the execution code
+	 * itself, for example).
+	 * @type Array
+	 * @example
+	 * alert( 'Number of UI items associated to this command: ' + command.<b>uiItems</b>.length );
+	 */
 	this.uiItems = [];
 
+	/**
+	 * Executes the command.
+	 * @param {Object} [data] Any data to pass to the command. Depends on the
+	 *		command implementation and requirements.
+	 * @returns {Boolean} A boolean indicating that the command has been
+	 *      successfully executed.
+	 * @example
+	 * command.<b>exec()</b>;  // The command gets executed.
+	 */
 	this.exec = function( data )
 	{
@@ -21,7 +55,54 @@
 	CKEDITOR.tools.extend( this, commandDefinition,
 		// Defaults
+		/** @lends CKEDITOR.command.prototype */
 		{
+			/**
+			 * The editor modes within which the command can be executed. The
+			 * execution will have no action if the current mode is not listed
+			 * in this property.
+			 * @type Object
+			 * @default { wysiwyg : 1 }
+			 * @see CKEDITOR.editor.prototype.mode
+			 * @example
+			 * // Enable the command in both WYSIWYG and Source modes.
+			 * command.<b>modes</b> = { wysiwyg : 1, source : 1 };
+			 * @example
+			 * // Enable the command in Source mode only.
+			 * command.<b>modes</b> = { source : 1 };
+			 */
 			modes : { wysiwyg : 1 },
-			editorFocus : true,
+
+			/**
+			 * Indicates that the editor will get the focus before executing
+			 * the command.
+			 * @type Boolean
+			 * @default true
+			 * @example
+			 * // Do not force the editor to have focus when executing the command.
+			 * command.<b>editorFocus</b> = false;
+			 */
+			editorFocus : 1,
+
+			/**
+			 * Indicates the editor state. Possible values are:
+			 * <ul>
+			 * <li>{@link CKEDITOR.TRISTATE_DISABLED}: the command is
+			 *		disabled. It's execution will have no effect. Same as
+			 *		{@link disable}.</li>
+			 * <li>{@link CKEDITOR.TRISTATE_ON}: the command is enabled
+			 *		and currently active in the editor (for context sensitive commands,
+			 *		for example).</li>
+			 * <li>{@link CKEDITOR.TRISTATE_OFF}: the command is enabled
+			 *		and currently inactive in the editor (for context sensitive
+			 *		commands, for example).</li>
+			 * </ul>
+			 * Do not set this property directly, using the {@link #setState}
+			 * method instead.
+			 * @type Number
+			 * @default {@link CKEDITOR.TRISTATE_OFF}
+			 * @example
+			 * if ( command.<b>state</b> == CKEDITOR.TRISTATE_DISABLED )
+			 *     alert( 'This command is disabled' );
+			 */
 			state : CKEDITOR.TRISTATE_OFF
 		});
@@ -33,4 +114,12 @@
 CKEDITOR.command.prototype =
 {
+	/**
+	 * Enables the command for execution. The command state (see
+	 * {@link CKEDITOR.command.prototype.state}) available before disabling it
+	 * is restored.
+	 * @example
+	 * command.<b>enable()</b>;
+	 * command.exec();    // Execute the command.
+	 */
 	enable : function()
 	{
@@ -39,4 +128,12 @@
 	},
 
+	/**
+	 * Disables the command for execution. The command state (see
+	 * {@link CKEDITOR.command.prototype.state}) will be set to
+	 * {@link CKEDITOR.TRISTATE_DISABLED}.
+	 * @example
+	 * command.<b>disable()</b>;
+	 * command.exec();    // "false" - Nothing happens.
+	 */
 	disable : function()
 	{
@@ -44,4 +141,16 @@
 	},
 
+	/**
+	 * Sets the command state.
+	 * @param {Number} newState The new state. See {@link #state}.
+	 * @returns {Boolean} Returns "true" if the command state changed.
+	 * @example
+	 * command.<b>setState( CKEDITOR.TRISTATE_ON )</b>;
+	 * command.exec();    // Execute the command.
+	 * command.<b>setState( CKEDITOR.TRISTATE_DISABLED )</b>;
+	 * command.exec();    // "false" - Nothing happens.
+	 * command.<b>setState( CKEDITOR.TRISTATE_OFF )</b>;
+	 * command.exec();    // Execute the command.
+	 */
 	setState : function( newState )
 	{
@@ -62,4 +171,10 @@
 	},
 
+	/**
+	 * Toggles the on/off (active/inactive) state of the command. This is
+	 * mainly used internally by context sensitive commands.
+	 * @example
+	 * command.<b>toggleState()</b>;
+	 */
 	toggleState : function()
 	{
@@ -72,2 +187,23 @@
 
 CKEDITOR.event.implementOn( CKEDITOR.command.prototype, true );
+
+/**
+ * Indicates the preivous command state.
+ * @name CKEDITOR.command.prototype.previousState
+ * @type Number
+ * @see #state
+ * @example
+ * alert( command.<b>previousState</b> );
+ */
+
+/**
+ * Fired when the command state changes.
+ * @name CKEDITOR.command#state
+ * @event
+ * @example
+ * command.on( <b>'state'</b> , function( e )
+ *     {
+ *         // Alerts the new state.
+ *         alert( this.state );
+ *     });
+ */
Index: CKEditor/branches/versions/3.5.x/_source/core/commanddefinition.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/commanddefinition.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/commanddefinition.js	(revision 6050)
@@ -12,13 +12,13 @@
 /**
  * (Virtual Class) Do not call this constructor. This class is not really part
- *		of the API. It just illustrates the features of command objects to be
+ * of the API.
+ * @name CKEDITOR.commandDefinition
+ * @class Virtual class that illustrates the features of command objects to be
  *		passed to the {@link CKEDITOR.editor.prototype.addCommand} function.
- * @name CKEDITOR.commandDefinition
- * @constructor
  * @example
  */
 
  /**
- * Executes the command.
+ * The function to be fired when the commend is executed.
  * @name CKEDITOR.commandDefinition.prototype.exec
  * @function
@@ -39,7 +39,7 @@
 /**
  * Whether the command need to be hooked into the redo/undo system.
- * @name  CKEDITOR.commandDefinition.canUndo
- * @type {Boolean} If not defined or 'true' both hook into undo system, set it
- *		to 'false' explicitly  keep it out.
+ * @name  CKEDITOR.commandDefinition.prototype.canUndo
+ * @type {Boolean}
+ * @default true
  * @field
  * @example
@@ -55,16 +55,21 @@
 
 /**
- * Whether the command is asynchronous, which means the 'afterCommandExec' event
- * will be fired by the command itself manually, and the 'exec' function return value
- * of this command is not to be returned.
- * @name  CKEDITOR.commandDefinition.async
- * @type {Boolean} If defined as 'true', the command is asynchronous.
+ * Whether the command is asynchronous, which means that the
+ * {@link CKEDITOR.editor#event:afterCommandExec} event will be fired by the
+ * command itself manually, and that the return value of this command is not to
+ * be returned by the {@link CKEDITOR.command#exec} function.
+ * @name  CKEDITOR.commandDefinition.prototype.async
+ * @default false
+ * @type {Boolean}
  * @example
- * editorInstance.addCommand( 'alertName',
+ * editorInstance.addCommand( 'loadOptions',
  * {
  *     exec : function( editor )
  *     {
  *         // Asynchronous operation below.
- *         CKEDITOR.ajax.loadXml( 'data.xml' );
+ *         CKEDITOR.ajax.loadXml( 'data.xml', function()
+ *             {
+ *                 editor.fire( 'afterCommandExec' );
+ *             ));
  *     },
  *     async : true    // The command need some time to complete after exec function returns.
@@ -74,6 +79,8 @@
 /**
  * Whether the command should give focus to the editor before execution.
- * @name  CKEDITOR.commandDefinition.editorFocus
+ * @name  CKEDITOR.commandDefinition.prototype.editorFocus
  * @type {Boolean}
+ * @default true
+ * @see CKEDITOR.command#editorFocus
  * @example
  * editorInstance.addCommand( 'maximize',
@@ -81,4 +88,5 @@
  *     exec : function( editor )
  *     {
+ *         // ...
  *     },
  *     editorFocus : false    // The command doesn't require focusing the editing document.
@@ -89,5 +97,5 @@
 /**
  * Whether the command state should be set to {@link CKEDITOR.TRISTATE_DISABLED} on startup.
- * @name  CKEDITOR.commandDefinition.startDisabled
+ * @name  CKEDITOR.commandDefinition.prototype.startDisabled
  * @type {Boolean}
  * @default false
@@ -97,6 +105,25 @@
  *     exec : function( editor )
  *     {
+ *         // ...
  *     },
  *     startDisabled : true    // Command is unavailable until selection is inside a link.
  * });
  */
+
+/**
+ * The editor modes within which the command can be executed. The execution
+ * will have no action if the current mode is not listed in this property.
+ * @name  CKEDITOR.commandDefinition.prototype.modes
+ * @type Object
+ * @default { wysiwyg : 1 }
+ * @see CKEDITOR.command#modes
+ * @example
+ * editorInstance.addCommand( 'link',
+ * {
+ *     exec : function( editor )
+ *     {
+ *         // ...
+ *     },
+ *     modes : { wysiwyg : 1 }    // Command is available in wysiwyg mode only.
+ * });
+ */
Index: CKEditor/branches/versions/3.5.x/_source/core/config.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/config.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/config.js	(revision 6050)
@@ -9,17 +9,32 @@
  */
 
+/**
+ * Used in conjuction with {@link CKEDITOR.config.enterMode} and
+ * {@link CKEDITOR.config.shiftEnterMode} to make the editor produce &lt;p&gt;
+ * tags when using the ENTER key.
+ * @constant
+ */
 CKEDITOR.ENTER_P	= 1;
+
+/**
+ * Used in conjuction with {@link CKEDITOR.config.enterMode} and
+ * {@link CKEDITOR.config.shiftEnterMode} to make the editor produce &lt;br&gt;
+ * tags when using the ENTER key.
+ * @constant
+ */
 CKEDITOR.ENTER_BR	= 2;
+
+/**
+ * Used in conjuction with {@link CKEDITOR.config.enterMode} and
+ * {@link CKEDITOR.config.shiftEnterMode} to make the editor produce &lt;div&gt;
+ * tags when using the ENTER key.
+ * @constant
+ */
 CKEDITOR.ENTER_DIV	= 3;
 
 /**
- * Holds the default configuration settings. Changes to this object are
+ * @namespace Holds the default configuration settings. Changes to this object are
  * reflected in all editor instances, if not specificaly specified for those
  * instances.
- * @namespace
- * @example
- * // All editor created after the following setting will not load custom
- * // configuration files.
- * CKEDITOR.config.customConfig = '';
  */
 CKEDITOR.config =
@@ -57,5 +72,5 @@
 	 * editor content.
 	 * @type String
-	 * @default '' (empty string)
+	 * @default '' (empty)
 	 * @example
 	 * config.baseHref = 'http://www.example.com/path/';
@@ -195,8 +210,13 @@
 	/**
 	 * Sets the "id" attribute to be used on the body element of the editing
-	 * area.
+	 * area. This can be useful when reusing the original CSS file you're using
+	 * on your live website and you want to assing to the editor the same id
+	 * you're using for the region that'll hold the contents. In this way,
+	 * id specific CSS rules will be enabled.
 	 * @since 3.1
 	 * @type String
-	 * @default ''
+	 * @default '' (empty)
+	 * @example
+	 * config.bodyId = 'contents_id';
 	 */
 	bodyId : '',
@@ -204,8 +224,13 @@
 	/**
 	 * Sets the "class" attribute to be used on the body element of the editing
-	 * area.
+	 * area. This can be useful when reusing the original CSS file you're using
+	 * on your live website and you want to assing to the editor the same class
+	 * name you're using for the region that'll hold the contents. In this way,
+	 * class specific CSS rules will be enabled.
 	 * @since 3.1
 	 * @type String
-	 * @default ''
+	 * @default '' (empty)
+	 * @example
+	 * config.bodyClass = 'contents';
 	 */
 	bodyClass : '',
@@ -244,5 +269,62 @@
 	 * @example
 	 */
-	plugins : 'about,a11yhelp,basicstyles,bidi,blockquote,button,clipboard,colorbutton,colordialog,contextmenu,dialogadvtab,div,elementspath,enterkey,entities,filebrowser,find,flash,font,format,forms,horizontalrule,htmldataprocessor,iframe,image,indent,justify,keystrokes,link,list,liststyle,maximize,newpage,pagebreak,pastefromword,pastetext,popup,preview,print,removeformat,resize,save,scayt,smiley,showblocks,showborders,sourcearea,stylescombo,table,tabletools,specialchar,tab,templates,toolbar,undo,wysiwygarea,wsc',
+	plugins :
+		'about,' +
+		'a11yhelp,' +
+		'basicstyles,' +
+		'bidi,' +
+		'blockquote,' +
+		'button,' +
+		'clipboard,' +
+		'colorbutton,' +
+		'colordialog,' +
+		'contextmenu,' +
+		'dialogadvtab,' +
+		'div,' +
+		'elementspath,' +
+		'enterkey,' +
+		'entities,' +
+		'filebrowser,' +
+		'find,' +
+		'flash,' +
+		'font,' +
+		'format,' +
+		'forms,' +
+		'horizontalrule,' +
+		'htmldataprocessor,' +
+		'iframe,' +
+		'image,' +
+		'indent,' +
+		'justify,' +
+		'keystrokes,' +
+		'link,' +
+		'list,' +
+		'liststyle,' +
+		'maximize,' +
+		'newpage,' +
+		'pagebreak,' +
+		'pastefromword,' +
+		'pastetext,' +
+		'popup,' +
+		'preview,' +
+		'print,' +
+		'removeformat,' +
+		'resize,' +
+		'save,' +
+		'scayt,' +
+		'smiley,' +
+		'showblocks,' +
+		'showborders,' +
+		'sourcearea,' +
+		'stylescombo,' +
+		'table,' +
+		'tabletools,' +
+		'specialchar,' +
+		'tab,' +
+		'templates,' +
+		'toolbar,' +
+		'undo,' +
+		'wysiwygarea,' +
+		'wsc',
 
 	/**
@@ -332,8 +414,8 @@
 
 /**
- * Indicates that some of the editor features, like alignement and text
+ * Indicates that some of the editor features, like alignment and text
  * direction, should used the "computed value" of the feature to indicate it's
- * on/off state, instead of using the "real value".
- *
+ * on/off state, instead of using the "real value".<br />
+ * <br />
  * If enabled, in a left to right written document, the "Left Justify"
  * alignment button will show as active, even if the aligment style is not
Index: CKEditor/branches/versions/3.5.x/_source/core/dataprocessor.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/dataprocessor.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/dataprocessor.js	(revision 6050)
@@ -16,16 +16,15 @@
  * which handles HTML data. The editor may also handle other data formats by
  * using different data processors provided by specific plugins.
- * @name CKEDITOR.editor.dataProcessor
+ * @name CKEDITOR.editor.prototype.dataProcessor
  * @type CKEDITOR.dataProcessor
  */
 
 /**
- * Represents a data processor, which is responsible to translate and transform
- * the editor data on input and output.
- * This class is not really part of the API. It's here for documentation
- * purposes, and serves as the base ("interface") for data processors
+ * This class is here for documentation purposes only and is not really part of
+ * the API. It serves as the base ("interface") for data processors
  * implementation.
  * @name CKEDITOR.dataProcessor
- * @contructor
+ * @class Represents a data processor, which is responsible to translate and
+ *        transform the editor data on input and output.
  * @example
  */
Index: CKEditor/branches/versions/3.5.x/_source/core/dom.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/dom.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/dom.js	(revision 6050)
@@ -10,8 +10,7 @@
 
 /**
- * DOM manipulation objects and function.<br /><br />
+ * @namespace DOM manipulation objects, classes and functions.
  * @see CKEDITOR.dom.element
  * @see CKEDITOR.dom.node
- * @namespace
  * @example
  */
Index: CKEditor/branches/versions/3.5.x/_source/core/dom/documentfragment.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/dom/documentfragment.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/dom/documentfragment.js	(revision 6050)
@@ -3,11 +3,11 @@
 For licensing, see LICENSE.html or http://ckeditor.com/license
 */
+
 /**
- * DocumentFragment is a "lightweight" or "minimal" Document object. It is
+ * @class DocumentFragment is a "lightweight" or "minimal" Document object. It is
  * commonly used to extract a portion of a document's tree or to create a new
  * fragment of a document. Various operations may take DocumentFragment objects
  * as arguments and results in all the child nodes of the DocumentFragment being
  * moved to the child list of this node.
- *
  * @param {Object} ownerDocument
  */
Index: CKEditor/branches/versions/3.5.x/_source/core/dom/domobject.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/dom/domobject.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/dom/domobject.js	(revision 6050)
@@ -85,8 +85,8 @@
 				var listener = nativeListeners[ eventName ] = getNativeListener( this, eventName );
 
-				if ( this.$.addEventListener )
+				if ( this.$.attachEvent )
+					this.$.attachEvent( 'on' + eventName, listener );
+				else if ( this.$.addEventListener )
 					this.$.addEventListener( eventName, listener, !!CKEDITOR.event.useCapture );
-				else if ( this.$.attachEvent )
-					this.$.attachEvent( 'on' + eventName, listener );
 			}
 
@@ -108,8 +108,8 @@
 				if ( listener )
 				{
-					if ( this.$.removeEventListener )
+					if ( this.$.detachEvent )
+						this.$.detachEvent( 'on' + eventName, listener );
+					else if ( this.$.removeEventListener )
 						this.$.removeEventListener( eventName, listener, false );
-					else if ( this.$.detachEvent )
-						this.$.detachEvent( 'on' + eventName, listener );
 
 					delete nativeListeners[ eventName ];
@@ -129,8 +129,8 @@
 			{
 				var listener = nativeListeners[ eventName ];
-				if ( this.$.removeEventListener )
+				if ( this.$.detachEvent )
+					this.$.detachEvent( 'on' + eventName, listener );
+				else if ( this.$.removeEventListener )
 					this.$.removeEventListener( eventName, listener, false );
-				else if ( this.$.detachEvent )
-					this.$.detachEvent( 'on' + eventName, listener );
 
 				delete nativeListeners[ eventName ];
@@ -239,5 +239,9 @@
 
 	/**
-	 * @name CKEDITOR.dom.domObject.prototype.getCustomData
+	 * Gets an ID that can be used to identiquely identify this DOM object in
+	 * the running session.
+	 * @name CKEDITOR.dom.domObject.prototype.getUniqueId
+	 * @function
+	 * @returns {Number} A unique ID.
 	 */
 	domObjectProto.getUniqueId = function()
Index: CKEditor/branches/versions/3.5.x/_source/core/dom/element.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/dom/element.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/dom/element.js	(revision 6050)
@@ -89,5 +89,5 @@
 {
 	for ( var i in database )
-		CKEDITOR.dom.element.clearMarkers( database, database[i], true );
+		CKEDITOR.dom.element.clearMarkers( database, database[i], 1 );
 };
 
@@ -1171,5 +1171,5 @@
 				{
 					this.$.style.MozUserSelect = 'none';
-					this.on( 'dragstart', function (evt) { evt.data.preventDefault(); } );
+					this.on( 'dragstart', function( evt ) { evt.data.preventDefault(); } );
 				}
 			: CKEDITOR.env.webkit ?
@@ -1177,5 +1177,5 @@
 				{
 					this.$.style.KhtmlUserSelect = 'none';
-					this.on( 'dragstart', function (evt) { evt.data.preventDefault(); } );
+					this.on( 'dragstart', function( evt ) { evt.data.preventDefault(); } );
 				}
 			:
@@ -1523,4 +1523,42 @@
 						event.data.preventDefault();
 				} );
+		},
+
+		/**
+		 *  Update the element's size with box model awareness.
+		 * @name CKEDITOR.dom.element.setSize
+		 * @param {String} type [width|height]
+		 * @param {Number} size The length unit in px.
+		 * @param isBorderBox Apply the {@param width} and {@param height} based on border box model.
+		 */
+		setSize : ( function()
+		{
+			var sides = {
+				width : [ "border-left-width", "border-right-width","padding-left", "padding-right" ],
+				height : [ "border-top-width", "border-bottom-width", "padding-top",  "padding-bottom" ]
+			};
+
+			return function( type, size, isBorderBox )
+				{
+					if ( typeof size == 'number' )
+					{
+						if ( isBorderBox && !( CKEDITOR.env.ie && CKEDITOR.env.quirks ) )
+						{
+							var	adjustment = 0;
+							for ( var i = 0, len = sides[ type ].length; i < len; i++ )
+								adjustment += parseInt( this.getComputedStyle( sides [ type ][ i ] ) || 0, 10 ) || 0;
+							size -= adjustment;
+						}
+						this.setStyle( type, size + 'px' );
+					}
+				};
+		})(),
+
+		/**
+		 * Gets element's direction. Supports both CSS 'direction' prop and 'dir' attr.
+		 */
+		getDirection : function( useComputed )
+		{
+			return useComputed ? this.getComputedStyle( 'direction' ) : this.getStyle( 'direction' ) || this.getAttribute( 'dir' );
 		}
 	});
Index: CKEditor/branches/versions/3.5.x/_source/core/dom/elementpath.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/dom/elementpath.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/dom/elementpath.js	(revision 6050)
@@ -28,4 +28,7 @@
 	};
 
+	/**
+	 * @class
+	 */
 	CKEDITOR.dom.elementPath = function( lastNode )
 	{
Index: CKEditor/branches/versions/3.5.x/_source/core/dom/nodelist.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/dom/nodelist.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/dom/nodelist.js	(revision 6050)
@@ -4,4 +4,7 @@
 */
 
+/**
+ * @class
+ */
 CKEDITOR.dom.nodeList = function( nativeList )
 {
Index: CKEditor/branches/versions/3.5.x/_source/core/dom/range.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/core/dom/range.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/core/dom/range.js	(revision 6050)
@@ -4,4 +4,7 @@
 */
 
+/**
+ * @class
+ */
 CKEDITOR.dom.range = function( document )
 {
@@ -1301,5 +1304,6 @@
 				}
 
-				var walker = new CKEDITOR.dom.walker( walkerRange );
+				var walker = new CKEDITOR.dom.walker( walkerRange ),
+					isBookmark = CKEDITOR.dom.walker.bookmark();
 
 				walker.evaluator = function( node )
@@ -1312,4 +1316,7 @@
 				walker.guard = function( node, movingOut )
 				{
+					if ( isBookmark( node ) )
+						return true;
+
 					// Stop when we're shrink in element mode while encountering a text node.
 					if ( mode == CKEDITOR.SHRINK_ELEMENT && node.type == CKEDITOR.NODE_TEXT )
@@ -1430,5 +1437,5 @@
 			if( endNode.type == CKEDITOR.NODE_ELEMENT
 				&& CKEDITOR.dtd.$empty[ endNode.getName() ] )
-				endNode = endNode.getParent(), endOffset = endNode.getIndex() + 1;
+				endOffset = endNode.getIndex() + 1, endNode = endNode.getParent();
 
 			this.endContainer	= endNode;
@@ -1865,16 +1872,12 @@
 CKEDITOR.ENLARGE_LIST_ITEM_CONTENTS = 3;
 
-/**
- * Check boundary types.
- * @see CKEDITOR.dom.range.prototype.checkBoundaryOfElement
- */
+// Check boundary types.
+// @see CKEDITOR.dom.range.prototype.checkBoundaryOfElement
 CKEDITOR.START = 1;
 CKEDITOR.END = 2;
 CKEDITOR.STARTEND = 3;
 
-/**
- * Shrink range types.
- * @see CKEDITOR.dom.range.prototype.shrink
- */
+// Shrink range types.
+// @see CKEDITOR.dom.range.prototype.shrink
 CKEDITOR.SHRINK_ELEMENT = 1;
 CKEDITOR.SHRINK_TEXT = 2;
